import { createApp } from 'vue'
import App from './App.vue'
import './index.css'
import router from './router'
import { createPinia } from 'pinia'
import { SET_CURRENT_ACCOUNT, SET_CURRENT_BUDGET } from './store/action-types'

const app = createApp(App)
app.use(router)
app.use(createPinia())
app.mount('#app')

router.beforeEach(async (to, from, next) => {
  await store.dispatch(SET_CURRENT_BUDGET, to.params.budgetid);
  await store.dispatch(SET_CURRENT_ACCOUNT, {
        accountid: to.params.accountid,
        budgetid: to.params.budgetid
  });
  next();
})
