export const store = createStore<State>({
    actions: {
        [IMPORT_YNAB]({ getters, dispatch }, formData) {
            return dispatch("POST", { path: "/budget/" + getters.CurrentBudget.ID + "/import/ynab", body: formData });
        },
        [GET]({ getters }, { path }) {
            return fetch("/api/v1" + path, {
                headers: getters.AuthHeaders,
            })
        },
        [POST]({ getters }, { path, body }) {
            return fetch("/api/v1" + path, {
                method: "POST",
                headers: getters.AuthHeaders,
                body: body,
            })
        },
        /*async fetchDashboard ({state, commit, rootState}) {
            const response = await fetch("/api/v1/dashboard", {
                headers: {
                    'Authorization': 'Bearer ' + rootState.Session.Token
                }
            })
            const data = await response.json();
            commit("setBudgets", data.Budgets);
        },*/
        async [NEW_BUDGET]({ state, commit, dispatch, rootState }, budgetName) {
            const result = await dispatch("POST", {
                path: "/budget/new",
                body: JSON.stringify({ name: budgetName })
            });
            const response = await result.json();
            commit("addBudget", response)
        },
        async [SET_CURRENT_BUDGET]({ state, commit, dispatch, rootState }, budgetid) {
            commit("setCurrentBudgetID", budgetid);

            if (budgetid == null)
                return

            await dispatch(FETCH_BUDGET, budgetid)
        },
    },
    plugins: [createLogger()],
    modules: {
        budget: budgetStore
    }
})

store.subscribe((mutation, state) => {

    const sessionStore = useSessionStore();
    let persistedState = {
        Session: sessionStore,
//        Accounts: [...state.Accounts],
        CurrentBudgetID: state.CurrentBudgetID,
        //CurrentAccountID: state.CurrentAccountID,
        ExpandMenu: state.ExpandMenu,
        ShowMenu: state.ShowMenu
    }
    localStorage.setItem("store", JSON.stringify(persistedState));
})